#!/usr/bin/perl

use strict;
use warnings;
use UI::Dialog::Backend::CDialog;
use VASM::Resource::Message;
use VASM::Resource::Action;

local $\ = "\n";

# Message files
my $CommonMessage = findMessageCatalog(qw/Common Message/);
my $UIMessage = findMessageCatalog(qw/Action UI Common Message/);
#my $CDialogMessage = findMessageCatalog(qw/Action UI CDialog Message/);
my $ErrorMessage = findErrorCatalog(qw/Action UI Common Error/);

# Dialog instance
my $dialog = UI::Dialog::Backend::CDialog->new(
  backtitle => $CommonMessage->Render(ID => 'VASM Title'),
  'ok-label' => $CommonMessage->Render(ID => 'OK'),
  'cancel-label' => $CommonMessage->Render(ID => 'Cancel'),
  'yes-label' => $CommonMessage->Render(ID => 'Yes'),
  'no-label' => $CommonMessage->Render(ID => 'No'),
  width => 75,
  height => 20,
  menuheight => 10
);

### Main menu
my $main = $dialog->menu(
  title => $UIMessage->Render(ID => 'Title'),
  text => $UIMessage->Render(ID => 'Main Menu Description'),
  list => 
    [ map {
        $UIMessage->Render(ID => $_),
        $UIMessage->Render(ID => "$_ Description")
      }
      qw/File URI Template/ ]);

if ($main eq 'File' or $main eq 'URI') { ### Media menu
  my $directory = mediaDirectory($main);
  my @path = ($main,
              split # For MIME types
                m!/!,
              $dialog->menu(
                title => $UIMessage->Render(ID => 'Title'),
                text => $UIMessage->Render(ID => 'Media Menu Description'),
                list => 
                  [ map {
                      $_, $directory->Render(ID => $_)
                    } sort $directory->List ] ));

  ### Operations menu
  my $operation =
    $dialog->menu(title =>
                    $UIMessage->Render(ID => 'Title'),
                  text =>
                    $UIMessage->Render(ID =>
                                         'Operation Menu Description',
                                       Arguments =>
                                         [ join '/', @path[1..2] ]),
                  list =>
                    [ map {
                        $UIMessage->Render(ID => "$_ Operation"),
                        $UIMessage->Render(ID => "$_ Operation Description")
                      } qw/List Add Remove/ ] );
  my $catalog = findActionCatalog()

  if ($operation eq 'List') { ### List Operation
    
  } elsif ($operation eq 'Add') { ### Add Operation
    
  } elsif ($operation eq 'Remove') { ### Remove Operation
    
  }

  # Get list of media types and sort
  # Offer to List, Add, Remove

} elsif ($main eq 'Template') { ### Template menu
  # List templates
}
